<?php

/*
 * Displays a list of tweets that are scheduled for broadcast to twitter.
 */
function twitter_queue_scheduled_tweets() {
  $header = array(
    array('data' => t('Tweet'), 'field' => 'n.title'),
    array('data' => t('Author'), 'field' => 'u.name'),
    array('data' => t('Broadcast on'), 'field' => 'tq.broadcast_on'),
    array('data' => t('Operations')),
  );

  // Default Ordering
  if (!isset($_GET['order']) && !isset($_GET['sort'])) {
    $_GET['order'] = t('Broadcast on');
    $_GET['sort'] = 'ASC';
  }

  $sql = 'SELECT n.nid, n.uid, n.status, u.name, n.title, tq.broadcast_on FROM {twitter_queue} tq LEFT JOIN {node} n ON tq.nid = n.nid LEFT JOIN {users} u ON n.uid = u.uid' . tablesort_sql($header);
  $result = pager_query($sql, 50);

  while ($node = db_fetch_object($result)) {
    $rows[] = array(
      l($node->title, "node/$node->nid"),
      theme('username', $node),
      ($node->broadcast_on ? format_date($node->broadcast_on) : '&nbsp;'),
      l(t('edit'), 'node/'. $node->nid .'/edit', array(), 'destination=admin/content/node/twitter-queue'),
    );
  }

  if (count($rows)) {
    if ($pager = theme('pager', NULL, 50, 0)) {
      $rows[] = array(array('data' => $pager, 'colspan' => 6));
    }

    print theme('page', theme('table', $header, $rows));
  }
  else {
    print theme('page', t('There are no tweets scheduled for broadcast.'));
  }
}
